package cn.com.infosec.asn1.cryptopro;

import cn.com.infosec.asn1.ASN1Encodable;
import cn.com.infosec.asn1.ASN1EncodableVector;
import cn.com.infosec.asn1.ASN1Sequence;
import cn.com.infosec.asn1.ASN1TaggedObject;
import cn.com.infosec.asn1.DERInteger;
import cn.com.infosec.asn1.DERObject;
import cn.com.infosec.asn1.DERSequence;
import java.math.BigInteger;
import java.util.Enumeration;

public class ECGOST3410ParamSetParameters extends ASN1Encodable {
   DERInteger p;
   DERInteger q;
   DERInteger a;
   DERInteger b;
   DERInteger x;
   DERInteger y;

   public static ECGOST3410ParamSetParameters getInstance(ASN1TaggedObject obj, boolean explicit) {
      return getInstance(ASN1Sequence.getInstance(obj, explicit));
   }

   public static ECGOST3410ParamSetParameters getInstance(Object obj) {
      if (obj != null && !(obj instanceof ECGOST3410ParamSetParameters)) {
         if (obj instanceof ASN1Sequence) {
            return new ECGOST3410ParamSetParameters((ASN1Sequence)obj);
         } else {
            throw new IllegalArgumentException("Invalid GOST3410Parameter: " + obj.getClass().getName());
         }
      } else {
         return (ECGOST3410ParamSetParameters)obj;
      }
   }

   public ECGOST3410ParamSetParameters(BigInteger a, BigInteger b, BigInteger p, BigInteger q, int x, BigInteger y) {
      ECGOST3410ParamSetParameters var10000 = this;
      ECGOST3410ParamSetParameters var10001 = this;
      ECGOST3410ParamSetParameters var10002 = this;
      ECGOST3410ParamSetParameters var10003 = this;
      ECGOST3410ParamSetParameters var10004 = this;
      ECGOST3410ParamSetParameters var10005 = this;
      super();
      DERInteger var7;
      var7 = new DERInteger.<init>(a);
      var10005.a = var7;
      var7 = new DERInteger.<init>(b);
      var10004.b = var7;
      var7 = new DERInteger.<init>(p);
      var10003.p = var7;
      var7 = new DERInteger.<init>(q);
      var10002.q = var7;
      var7 = new DERInteger.<init>(x);
      var10001.x = var7;
      var7 = new DERInteger.<init>(y);
      var10000.y = var7;
   }

   public ECGOST3410ParamSetParameters(ASN1Sequence seq) {
      ECGOST3410ParamSetParameters var10000 = this;
      ECGOST3410ParamSetParameters var10001 = this;
      ECGOST3410ParamSetParameters var10002 = this;
      ECGOST3410ParamSetParameters var10003 = this;
      ECGOST3410ParamSetParameters var10004 = this;
      super();
      Enumeration var2;
      this.a = (DERInteger)(var2 = seq.getObjects()).nextElement();
      var10004.b = (DERInteger)var2.nextElement();
      var10003.p = (DERInteger)var2.nextElement();
      var10002.q = (DERInteger)var2.nextElement();
      var10001.x = (DERInteger)var2.nextElement();
      var10000.y = (DERInteger)var2.nextElement();
   }

   public BigInteger getP() {
      return this.p.getPositiveValue();
   }

   public BigInteger getQ() {
      return this.q.getPositiveValue();
   }

   public BigInteger getA() {
      return this.a.getPositiveValue();
   }

   public DERObject toASN1Object() {
      ASN1EncodableVector var1;
      ASN1EncodableVector var10000 = var1 = new ASN1EncodableVector;
      var1.<init>();
      var1.add(this.a);
      var1.add(this.b);
      var1.add(this.p);
      var1.add(this.q);
      var1.add(this.x);
      var10000.add(this.y);
      return new DERSequence(var1);
   }
}
